<!---
  This documentation is auto generated by a script.

  Please do not edit this file directly, check compile_docs task on lib/tasks/gitlab/graphql.rake.
--->

# GraphQL API Resources

This documentation is self-generated based on GitLab current GraphQL schema.

The API can be explored interactively using the [GraphiQL IDE](../index.md#graphiql).

Each table below documents a GraphQL type. Types match loosely to models, but not all
fields and methods on a model are available via GraphQL.

## AddAwardEmojiPayload

Autogenerated return type of AddAwardEmoji

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |

## AwardEmoji

An emoji awarded by a user.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `description` | String! | The emoji description |
| `emoji` | String! | The emoji as an icon |
| `name` | String! | The emoji name |
| `unicode` | String! | The emoji in unicode |
| `unicodeVersion` | String! | The unicode version for this emoji |
| `user` | User! | The user who awarded the emoji |

## Blob

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `flatPath` | String! | Flat path of the entry |
| `id` | ID! | ID of the entry |
| `lfsOid` | String | LFS ID of the blob |
| `name` | String! | Name of the entry |
| `path` | String! | Path of the entry |
| `sha` | String! | Last commit sha for the entry |
| `type` | EntryType! | Type of tree entry |
| `webUrl` | String | Web URL of the blob |

## Commit

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User | Author of the commit |
| `authorGravatar` | String | Commit authors gravatar |
| `authorName` | String | Commit authors name |
| `authoredDate` | Time | Timestamp of when the commit was authored |
| `description` | String | Description of the commit message |
| `id` | ID! | ID (global ID) of the commit |
| `latestPipeline` | Pipeline | Latest pipeline of the commit |
| `message` | String | Raw commit message |
| `sha` | String! | SHA1 ID of the commit |
| `signatureHtml` | String | Rendered HTML of the commit signature |
| `title` | String | Title of the commit message |
| `webUrl` | String! | Web URL of the commit |

## CreateDiffNotePayload

Autogenerated return type of CreateDiffNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `note` | Note | The note after mutation |

## CreateEpicPayload

Autogenerated return type of CreateEpic

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `epic` | Epic | The created epic |
| `errors` | String! => Array | Reasons why the mutation failed. |

## CreateImageDiffNotePayload

Autogenerated return type of CreateImageDiffNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `note` | Note | The note after mutation |

## CreateNotePayload

Autogenerated return type of CreateNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `note` | Note | The note after mutation |

## CreateSnippetPayload

Autogenerated return type of CreateSnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `snippet` | Snippet | The snippet after mutation |

## Design

A single design

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `diffRefs` | DiffRefs! | The diff refs for this design |
| `event` | DesignVersionEvent! | How this design was changed in the current version |
| `filename` | String! | The filename of the design |
| `fullPath` | String! | The full path to the design file |
| `id` | ID! | The ID of this design |
| `image` | String! | The URL of the image |
| `issue` | Issue! | The issue the design belongs to |
| `notesCount` | Int! | The total count of user-created notes for this design |
| `project` | Project! | The project the design belongs to |

## DesignAtVersion

A design pinned to a specific version. The image field reflects the design as of the associated version.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `design` | Design! | The underlying design. |
| `diffRefs` | DiffRefs! | The diff refs for this design |
| `event` | DesignVersionEvent! | How this design was changed in the current version |
| `filename` | String! | The filename of the design |
| `fullPath` | String! | The full path to the design file |
| `id` | ID! | The ID of this design |
| `image` | String! | The URL of the image |
| `issue` | Issue! | The issue the design belongs to |
| `notesCount` | Int! | The total count of user-created notes for this design |
| `project` | Project! | The project the design belongs to |
| `version` | DesignVersion! | The version this design-at-versions is pinned to |

## DesignCollection

A collection of designs.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `design` | Design | Find a specific design |
| `designAtVersion` | DesignAtVersion | Find a design as of a version |
| `issue` | Issue! | Issue associated with the design collection |
| `project` | Project! | Project associated with the design collection |
| `version` | DesignVersion | A specific version |

## DesignManagement

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `designAtVersion` | DesignAtVersion | Find a design as of a version |
| `version` | DesignVersion | Find a version |

## DesignManagementDeletePayload

Autogenerated return type of DesignManagementDelete

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `version` | DesignVersion | The new version in which the designs are deleted |

## DesignManagementUploadPayload

Autogenerated return type of DesignManagementUpload

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `designs` | Design! => Array | The designs that were uploaded by the mutation |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `skippedDesigns` | Design! => Array | Any designs that were skipped from the upload due to there being no change to their content since their last version |

## DesignVersion

A specific version in which designs were added, modified or deleted

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `designAtVersion` | DesignAtVersion! | A particular design as of this version, provided it is visible at this version |
| `id` | ID! | ID of the design version |
| `sha` | ID! | SHA of the design version |

## DestroyNotePayload

Autogenerated return type of DestroyNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `note` | Note | The note after mutation |

## DestroySnippetPayload

Autogenerated return type of DestroySnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `snippet` | Snippet | The snippet after mutation |

## DetailedStatus

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `detailsPath` | String! | Path of the details for the pipeline status |
| `favicon` | String! | Favicon of the pipeline status |
| `group` | String! | Group of the pipeline status |
| `hasDetails` | Boolean! | Indicates if the pipeline status has further details |
| `icon` | String! | Icon of the pipeline status |
| `label` | String! | Label of the pipeline status |
| `text` | String! | Text of the pipeline status |
| `tooltip` | String! | Tooltip associated with the pipeline status |

## DiffPosition

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `diffRefs` | DiffRefs! | Information about the branch, HEAD, and base at the time of commenting |
| `filePath` | String! | Path of the file that was changed |
| `height` | Int | Total height of the image |
| `newLine` | Int | Line on HEAD SHA that was changed |
| `newPath` | String | Path of the file on the HEAD SHA |
| `oldLine` | Int | Line on start SHA that was changed |
| `oldPath` | String | Path of the file on the start SHA |
| `positionType` | DiffPositionType! | Type of file the position refers to |
| `width` | Int | Total width of the image |
| `x` | Int | X position of the note |
| `y` | Int | Y position of the note |

## DiffRefs

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `baseSha` | String | Merge base of the branch the comment was made on |
| `headSha` | String! | SHA of the HEAD at the time the comment was made |
| `startSha` | String! | SHA of the branch being compared against |

## Discussion

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | Timestamp of the discussion's creation |
| `id` | ID! | ID of this discussion |
| `replyId` | ID! | ID used to reply to this discussion |

## Environment

Describes where code is deployed for a project

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `id` | ID! | ID of the environment |
| `name` | String! | Human-readable name of the environment |

## Epic

Represents an epic.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | Author of the epic |
| `closedAt` | Time | Timestamp of the epic's closure |
| `createdAt` | Time | Timestamp of the epic's creation |
| `descendantCounts` | EpicDescendantCount | Number of open and closed descendant epics and issues |
| `description` | String | Description of the epic |
| `downvotes` | Int! | Number of downvotes the epic has received |
| `dueDate` | Time | Due date of the epic |
| `dueDateFixed` | Time | Fixed due date of the epic |
| `dueDateFromMilestones` | Time | Inherited due date of the epic from milestones |
| `dueDateIsFixed` | Boolean | Indicates if the due date has been manually set |
| `group` | Group! | Group to which the epic belongs |
| `hasChildren` | Boolean! | Indicates if the epic has children |
| `hasIssues` | Boolean! | Indicates if the epic has direct issues |
| `healthStatus` | HealthStatus | Current health status. Available only when feature flag save_issuable_health_status is enabled. |
| `id` | ID! | ID of the epic |
| `iid` | ID! | Internal ID of the epic |
| `parent` | Epic | Parent epic of the epic |
| `reference` | String! | Internal reference of the epic. Returned in shortened format by default |
| `relationPath` | String | URI path of the epic-issue relationship |
| `relativePosition` | Int | The relative position of the epic in the epic tree |
| `startDate` | Time | Start date of the epic |
| `startDateFixed` | Time | Fixed start date of the epic |
| `startDateFromMilestones` | Time | Inherited start date of the epic from milestones |
| `startDateIsFixed` | Boolean | Indicates if the start date has been manually set |
| `state` | EpicState! | State of the epic |
| `subscribed` | Boolean! | Indicates the currently logged in user is subscribed to the epic |
| `title` | String | Title of the epic |
| `updatedAt` | Time | Timestamp of the epic's last activity |
| `upvotes` | Int! | Number of upvotes the epic has received |
| `userPermissions` | EpicPermissions! | Permissions for the current user on the resource |
| `webPath` | String! | Web path of the epic |
| `webUrl` | String! | Web URL of the epic |

## EpicDescendantCount

Counts of descendent epics.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `closedEpics` | Int | Number of closed sub-epics |
| `closedIssues` | Int | Number of closed epic issues |
| `openedEpics` | Int | Number of opened sub-epics |
| `openedIssues` | Int | Number of opened epic issues |

## EpicIssue

Relationship between an epic and an issue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | User that created the issue |
| `closedAt` | Time | Timestamp of when the issue was closed |
| `confidential` | Boolean! | Indicates the issue is confidential |
| `createdAt` | Time! | Timestamp of when the issue was created |
| `description` | String | Description of the issue |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `designCollection` | DesignCollection | Collection of design images associated with this issue |
| `designs` | DesignCollection | Deprecated. Use `designCollection` |
| `discussionLocked` | Boolean! | Indicates discussion is locked on the issue |
| `downvotes` | Int! | Number of downvotes the issue has received |
| `dueDate` | Time | Due date of the issue |
| `epic` | Epic | Epic to which this issue belongs |
| `epicIssueId` | ID! | ID of the epic-issue relation |
| `healthStatus` | HealthStatus | Current health status. Available only when feature flag save_issuable_health_status is enabled. |
| `id` | ID | Global ID of the epic-issue relation |
| `iid` | ID! | Internal ID of the issue |
| `milestone` | Milestone | Milestone of the issue |
| `reference` | String! | Internal reference of the issue. Returned in shortened format by default |
| `relationPath` | String | URI path of the epic-issue relation |
| `relativePosition` | Int | Relative position of the issue (used for positioning in epic tree and issue boards) |
| `state` | IssueState! | State of the issue |
| `subscribed` | Boolean! | Indicates the currently logged in user is subscribed to the issue |
| `taskCompletionStatus` | TaskCompletionStatus! | Task completion status of the issue |
| `timeEstimate` | Int! | Time estimate of the issue |
| `title` | String! | Title of the issue |
| `titleHtml` | String | The GitLab Flavored Markdown rendering of `title` |
| `totalTimeSpent` | Int! | Total time reported as spent on the issue |
| `updatedAt` | Time! | Timestamp of when the issue was last updated |
| `upvotes` | Int! | Number of upvotes the issue has received |
| `userNotesCount` | Int! | Number of user notes of the issue |
| `userPermissions` | IssuePermissions! | Permissions for the current user on the resource |
| `webPath` | String! | Web path of the issue |
| `webUrl` | String! | Web URL of the issue |
| `weight` | Int | Weight of the issue |

## EpicPermissions

Check permissions for the current user on an epic

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminEpic` | Boolean! | Indicates the user can perform `admin_epic` on this resource |
| `awardEmoji` | Boolean! | Indicates the user can perform `award_emoji` on this resource |
| `createEpic` | Boolean! | Indicates the user can perform `create_epic` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `destroyEpic` | Boolean! | Indicates the user can perform `destroy_epic` on this resource |
| `readEpic` | Boolean! | Indicates the user can perform `read_epic` on this resource |
| `readEpicIid` | Boolean! | Indicates the user can perform `read_epic_iid` on this resource |
| `updateEpic` | Boolean! | Indicates the user can perform `update_epic` on this resource |

## EpicSetSubscriptionPayload

Autogenerated return type of EpicSetSubscription

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `epic` | Epic | The epic after mutation |
| `errors` | String! => Array | Reasons why the mutation failed. |

## EpicTreeReorderPayload

Autogenerated return type of EpicTreeReorder

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |

## GrafanaIntegration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | Timestamp of the issue's creation |
| `enabled` | Boolean! | Indicates whether Grafana integration is enabled |
| `grafanaUrl` | String! | Url for the Grafana host for the Grafana integration |
| `id` | ID! | Internal ID of the Grafana integration |
| `token` | String! | API token for the Grafana integration. Field is permanently masked. |
| `updatedAt` | Time! | Timestamp of the issue's last activity |

## Group

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `autoDevopsEnabled` | Boolean | Indicates whether Auto DevOps is enabled for all projects within this group |
| `avatarUrl` | String | Avatar URL of the group |
| `description` | String | Description of the namespace |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `emailsDisabled` | Boolean | Indicates if a group has email notifications disabled |
| `epic` | Epic | Find a single epic |
| `epicsEnabled` | Boolean | Indicates if Epics are enabled for namespace |
| `fullName` | String! | Full name of the namespace |
| `fullPath` | ID! | Full path of the namespace |
| `groupTimelogsEnabled` | Boolean | Indicates if Group timelogs are enabled for namespace |
| `id` | ID! | ID of the namespace |
| `lfsEnabled` | Boolean | Indicates if Large File Storage (LFS) is enabled for namespace |
| `mentionsDisabled` | Boolean | Indicates if a group is disabled from getting mentioned |
| `name` | String! | Name of the namespace |
| `parent` | Group | Parent group |
| `path` | String! | Path of the namespace |
| `projectCreationLevel` | String | The permission level required to create projects in the group |
| `requestAccessEnabled` | Boolean | Indicates if users can request access to namespace |
| `requireTwoFactorAuthentication` | Boolean | Indicates if all users in this group are required to set up two-factor authentication |
| `rootStorageStatistics` | RootStorageStatistics | Aggregated storage statistics of the namespace. Only available for root namespaces |
| `shareWithGroupLock` | Boolean | Indicates if sharing a project with another group within this group is prevented |
| `subgroupCreationLevel` | String | The permission level required to create subgroups within the group |
| `twoFactorGracePeriod` | Int | Time before two-factor authentication is enforced |
| `userPermissions` | GroupPermissions! | Permissions for the current user on the resource |
| `visibility` | String | Visibility of the namespace |
| `webUrl` | String! | Web URL of the group |

## GroupPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `readGroup` | Boolean! | Indicates the user can perform `read_group` on this resource |

## Issue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | User that created the issue |
| `closedAt` | Time | Timestamp of when the issue was closed |
| `confidential` | Boolean! | Indicates the issue is confidential |
| `createdAt` | Time! | Timestamp of when the issue was created |
| `description` | String | Description of the issue |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `designCollection` | DesignCollection | Collection of design images associated with this issue |
| `designs` | DesignCollection | Deprecated. Use `designCollection` |
| `discussionLocked` | Boolean! | Indicates discussion is locked on the issue |
| `downvotes` | Int! | Number of downvotes the issue has received |
| `dueDate` | Time | Due date of the issue |
| `epic` | Epic | Epic to which this issue belongs |
| `healthStatus` | HealthStatus | Current health status. Available only when feature flag save_issuable_health_status is enabled. |
| `iid` | ID! | Internal ID of the issue |
| `milestone` | Milestone | Milestone of the issue |
| `reference` | String! | Internal reference of the issue. Returned in shortened format by default |
| `relativePosition` | Int | Relative position of the issue (used for positioning in epic tree and issue boards) |
| `state` | IssueState! | State of the issue |
| `subscribed` | Boolean! | Indicates the currently logged in user is subscribed to the issue |
| `taskCompletionStatus` | TaskCompletionStatus! | Task completion status of the issue |
| `timeEstimate` | Int! | Time estimate of the issue |
| `title` | String! | Title of the issue |
| `titleHtml` | String | The GitLab Flavored Markdown rendering of `title` |
| `totalTimeSpent` | Int! | Total time reported as spent on the issue |
| `updatedAt` | Time! | Timestamp of when the issue was last updated |
| `upvotes` | Int! | Number of upvotes the issue has received |
| `userNotesCount` | Int! | Number of user notes of the issue |
| `userPermissions` | IssuePermissions! | Permissions for the current user on the resource |
| `webPath` | String! | Web path of the issue |
| `webUrl` | String! | Web URL of the issue |
| `weight` | Int | Weight of the issue |

## IssuePermissions

Check permissions for the current user on a issue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminIssue` | Boolean! | Indicates the user can perform `admin_issue` on this resource |
| `createDesign` | Boolean! | Indicates the user can perform `create_design` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `destroyDesign` | Boolean! | Indicates the user can perform `destroy_design` on this resource |
| `readDesign` | Boolean! | Indicates the user can perform `read_design` on this resource |
| `readIssue` | Boolean! | Indicates the user can perform `read_issue` on this resource |
| `reopenIssue` | Boolean! | Indicates the user can perform `reopen_issue` on this resource |
| `updateIssue` | Boolean! | Indicates the user can perform `update_issue` on this resource |

## IssueSetConfidentialPayload

Autogenerated return type of IssueSetConfidential

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `issue` | Issue | The issue after mutation |

## IssueSetDueDatePayload

Autogenerated return type of IssueSetDueDate

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `issue` | Issue | The issue after mutation |

## IssueSetWeightPayload

Autogenerated return type of IssueSetWeight

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `issue` | Issue | The issue after mutation |

## Label

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `color` | String! | Background color of the label |
| `description` | String | Description of the label (Markdown rendered as HTML for caching) |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `id` | ID! | Label ID |
| `textColor` | String! | Text color of the label |
| `title` | String! | Content of the label |

## MarkAsSpamSnippetPayload

Autogenerated return type of MarkAsSpamSnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `snippet` | Snippet | The snippet after mutation |

## MergeRequest

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `allowCollaboration` | Boolean | Indicates if members of the target project can push to the fork |
| `createdAt` | Time! | Timestamp of when the merge request was created |
| `defaultMergeCommitMessage` | String | Default merge commit message of the merge request |
| `description` | String | Description of the merge request (Markdown rendered as HTML for caching) |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `diffHeadSha` | String | Diff head SHA of the merge request |
| `diffRefs` | DiffRefs | References of the base SHA, the head SHA, and the start SHA for this merge request |
| `discussionLocked` | Boolean! | Indicates if comments on the merge request are locked to members only |
| `downvotes` | Int! | Number of downvotes for the merge request |
| `forceRemoveSourceBranch` | Boolean | Indicates if the project settings will lead to source branch deletion after merge |
| `headPipeline` | Pipeline | The pipeline running on the branch HEAD of the merge request |
| `id` | ID! | ID of the merge request |
| `iid` | String! | Internal ID of the merge request |
| `inProgressMergeCommitSha` | String | Commit SHA of the merge request if merge is in progress |
| `mergeCommitMessage` | String | Deprecated - renamed to defaultMergeCommitMessage |
| `mergeCommitSha` | String | SHA of the merge request commit (set once merged) |
| `mergeError` | String | Error message due to a merge error |
| `mergeOngoing` | Boolean! | Indicates if a merge is currently occurring |
| `mergeStatus` | String | Status of the merge request |
| `mergeWhenPipelineSucceeds` | Boolean | Indicates if the merge has been set to be merged when its pipeline succeeds (MWPS) |
| `mergeableDiscussionsState` | Boolean | Indicates if all discussions in the merge request have been resolved, allowing the merge request to be merged |
| `milestone` | Milestone | The milestone of the merge request |
| `project` | Project! | Alias for target_project |
| `projectId` | Int! | ID of the merge request project |
| `rebaseCommitSha` | String | Rebase commit SHA of the merge request |
| `rebaseInProgress` | Boolean! | Indicates if there is a rebase currently in progress for the merge request |
| `reference` | String! | Internal reference of the merge request. Returned in shortened format by default |
| `shouldBeRebased` | Boolean! | Indicates if the merge request will be rebased |
| `shouldRemoveSourceBranch` | Boolean | Indicates if the source branch of the merge request will be deleted after merge |
| `sourceBranch` | String! | Source branch of the merge request |
| `sourceBranchExists` | Boolean! | Indicates if the source branch of the merge request exists |
| `sourceProject` | Project | Source project of the merge request |
| `sourceProjectId` | Int | ID of the merge request source project |
| `state` | MergeRequestState! | State of the merge request |
| `subscribed` | Boolean! | Indicates if the currently logged in user is subscribed to this merge request |
| `targetBranch` | String! | Target branch of the merge request |
| `targetProject` | Project! | Target project of the merge request |
| `targetProjectId` | Int! | ID of the merge request target project |
| `taskCompletionStatus` | TaskCompletionStatus! | Completion status of tasks |
| `timeEstimate` | Int! | Time estimate of the merge request |
| `title` | String! | Title of the merge request |
| `titleHtml` | String | The GitLab Flavored Markdown rendering of `title` |
| `totalTimeSpent` | Int! | Total time reported as spent on the merge request |
| `updatedAt` | Time! | Timestamp of when the merge request was last updated |
| `upvotes` | Int! | Number of upvotes for the merge request |
| `userNotesCount` | Int | User notes count of the merge request |
| `userPermissions` | MergeRequestPermissions! | Permissions for the current user on the resource |
| `webUrl` | String | Web URL of the merge request |
| `workInProgress` | Boolean! | Indicates if the merge request is a work in progress (WIP) |

## MergeRequestPermissions

Check permissions for the current user on a merge request

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminMergeRequest` | Boolean! | Indicates the user can perform `admin_merge_request` on this resource |
| `cherryPickOnCurrentMergeRequest` | Boolean! | Indicates the user can perform `cherry_pick_on_current_merge_request` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `pushToSourceBranch` | Boolean! | Indicates the user can perform `push_to_source_branch` on this resource |
| `readMergeRequest` | Boolean! | Indicates the user can perform `read_merge_request` on this resource |
| `removeSourceBranch` | Boolean! | Indicates the user can perform `remove_source_branch` on this resource |
| `revertOnCurrentMergeRequest` | Boolean! | Indicates the user can perform `revert_on_current_merge_request` on this resource |
| `updateMergeRequest` | Boolean! | Indicates the user can perform `update_merge_request` on this resource |

## MergeRequestSetAssigneesPayload

Autogenerated return type of MergeRequestSetAssignees

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetLabelsPayload

Autogenerated return type of MergeRequestSetLabels

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetLockedPayload

Autogenerated return type of MergeRequestSetLocked

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetMilestonePayload

Autogenerated return type of MergeRequestSetMilestone

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetSubscriptionPayload

Autogenerated return type of MergeRequestSetSubscription

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetWipPayload

Autogenerated return type of MergeRequestSetWip

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## Metadata

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `revision` | String! | Revision |
| `version` | String! | Version |

## Milestone

Represents a milestone.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | Timestamp of milestone creation |
| `description` | String | Description of the milestone |
| `dueDate` | Time | Timestamp of the milestone due date |
| `id` | ID! | ID of the milestone |
| `startDate` | Time | Timestamp of the milestone start date |
| `state` | MilestoneStateEnum! | State of the milestone |
| `title` | String! | Title of the milestone |
| `updatedAt` | Time! | Timestamp of last milestone update |
| `webPath` | String! | Web path of the milestone |

## Namespace

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `description` | String | Description of the namespace |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `fullName` | String! | Full name of the namespace |
| `fullPath` | ID! | Full path of the namespace |
| `id` | ID! | ID of the namespace |
| `lfsEnabled` | Boolean | Indicates if Large File Storage (LFS) is enabled for namespace |
| `name` | String! | Name of the namespace |
| `path` | String! | Path of the namespace |
| `requestAccessEnabled` | Boolean | Indicates if users can request access to namespace |
| `rootStorageStatistics` | RootStorageStatistics | Aggregated storage statistics of the namespace. Only available for root namespaces |
| `visibility` | String | Visibility of the namespace |

## Note

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | User who wrote this note |
| `body` | String! | Content of the note |
| `bodyHtml` | String | The GitLab Flavored Markdown rendering of `note` |
| `createdAt` | Time! | Timestamp of the note creation |
| `discussion` | Discussion | The discussion this note is a part of |
| `id` | ID! | ID of the note |
| `position` | DiffPosition | The position of this note on a diff |
| `project` | Project | Project associated with the note |
| `resolvable` | Boolean! | Indicates if this note can be resolved. That is, if it is a resolvable discussion or simply a standalone note |
| `resolvedAt` | Time | Timestamp of the note's resolution |
| `resolvedBy` | User | User that resolved the discussion |
| `system` | Boolean! | Indicates whether this note was created by the system or by a user |
| `updatedAt` | Time! | Timestamp of the note's last activity |
| `userPermissions` | NotePermissions! | Permissions for the current user on the resource |

## NotePermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminNote` | Boolean! | Indicates the user can perform `admin_note` on this resource |
| `awardEmoji` | Boolean! | Indicates the user can perform `award_emoji` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `readNote` | Boolean! | Indicates the user can perform `read_note` on this resource |
| `resolveNote` | Boolean! | Indicates the user can perform `resolve_note` on this resource |

## PageInfo

Information about pagination in a connection.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `endCursor` | String | When paginating forwards, the cursor to continue. |
| `hasNextPage` | Boolean! | When paginating forwards, are there more items? |
| `hasPreviousPage` | Boolean! | When paginating backwards, are there more items? |
| `startCursor` | String | When paginating backwards, the cursor to continue. |

## Pipeline

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `beforeSha` | String | Base SHA of the source branch |
| `committedAt` | Time | Timestamp of the pipeline's commit |
| `coverage` | Float | Coverage percentage |
| `createdAt` | Time! | Timestamp of the pipeline's creation |
| `detailedStatus` | DetailedStatus! | Detailed status of the pipeline |
| `duration` | Int | Duration of the pipeline in seconds |
| `finishedAt` | Time | Timestamp of the pipeline's completion |
| `id` | ID! | ID of the pipeline |
| `iid` | String! | Internal ID of the pipeline |
| `sha` | String! | SHA of the pipeline's commit |
| `startedAt` | Time | Timestamp when the pipeline was started |
| `status` | PipelineStatusEnum! | Status of the pipeline (CREATED, WAITING_FOR_RESOURCE, PREPARING, PENDING, RUNNING, FAILED, SUCCESS, CANCELED, SKIPPED, MANUAL, SCHEDULED) |
| `updatedAt` | Time! | Timestamp of the pipeline's last activity |
| `userPermissions` | PipelinePermissions! | Permissions for the current user on the resource |

## PipelinePermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminPipeline` | Boolean! | Indicates the user can perform `admin_pipeline` on this resource |
| `destroyPipeline` | Boolean! | Indicates the user can perform `destroy_pipeline` on this resource |
| `updatePipeline` | Boolean! | Indicates the user can perform `update_pipeline` on this resource |

## Project

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `archived` | Boolean | Indicates the archived status of the project |
| `autocloseReferencedIssues` | Boolean | Indicates if issues referenced by merge requests and commits within the default branch are closed automatically |
| `avatarUrl` | String | URL to avatar image file of the project |
| `containerRegistryEnabled` | Boolean | Indicates if the project stores Docker container images in a container registry |
| `createdAt` | Time | Timestamp of the project creation |
| `description` | String | Short description of the project |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `forksCount` | Int! | Number of times the project has been forked |
| `fullPath` | ID! | Full path of the project |
| `grafanaIntegration` | GrafanaIntegration | Grafana integration details for the project |
| `group` | Group | Group of the project |
| `httpUrlToRepo` | String | URL to connect to the project via HTTPS |
| `id` | ID! | ID of the project |
| `importStatus` | String | Status of project import background job of the project |
| `issue` | Issue | A single issue of the project |
| `issuesEnabled` | Boolean | (deprecated) Does this project have issues enabled?. Use `issues_access_level` instead |
| `jobsEnabled` | Boolean | (deprecated) Enable jobs for this project. Use `builds_access_level` instead |
| `lastActivityAt` | Time | Timestamp of the project last activity |
| `lfsEnabled` | Boolean | Indicates if the project has Large File Storage (LFS) enabled |
| `mergeRequest` | MergeRequest | A single merge request of the project |
| `mergeRequestsEnabled` | Boolean | (deprecated) Does this project have merge_requests enabled?. Use `merge_requests_access_level` instead |
| `mergeRequestsFfOnlyEnabled` | Boolean | Indicates if no merge commits should be created and all merges should instead be fast-forwarded, which means that merging is only allowed if the branch could be fast-forwarded. |
| `name` | String! | Name of the project (without namespace) |
| `nameWithNamespace` | String! | Full name of the project with its namespace |
| `namespace` | Namespace | Namespace of the project |
| `onlyAllowMergeIfAllDiscussionsAreResolved` | Boolean | Indicates if merge requests of the project can only be merged when all the discussions are resolved |
| `onlyAllowMergeIfPipelineSucceeds` | Boolean | Indicates if merge requests of the project can only be merged with successful jobs |
| `openIssuesCount` | Int | Number of open issues for the project |
| `path` | String! | Path of the project |
| `printingMergeRequestLinkEnabled` | Boolean | Indicates if a link to create or view a merge request should display after a push to Git repositories of the project from the command line |
| `publicJobs` | Boolean | Indicates if there is public access to pipelines and job details of the project, including output logs and artifacts |
| `removeSourceBranchAfterMerge` | Boolean | Indicates if `Delete source branch` option should be enabled by default for all new merge requests of the project |
| `repository` | Repository | Git repository of the project |
| `requestAccessEnabled` | Boolean | Indicates if users can request member access to the project |
| `sentryDetailedError` | SentryDetailedError | Detailed version of a Sentry error on the project |
| `sentryErrors` | SentryErrorCollection | Paginated collection of Sentry errors on the project |
| `serviceDeskAddress` | String | E-mail address of the service desk. |
| `serviceDeskEnabled` | Boolean | Indicates if the project has service desk enabled. |
| `sharedRunnersEnabled` | Boolean | Indicates if shared runners are enabled on the project |
| `snippetsEnabled` | Boolean | (deprecated) Does this project have snippets enabled?. Use `snippets_access_level` instead |
| `sshUrlToRepo` | String | URL to connect to the project via SSH |
| `starCount` | Int! | Number of times the project has been starred |
| `statistics` | ProjectStatistics | Statistics of the project |
| `suggestionCommitMessage` | String | The commit message used to apply merge request suggestions |
| `tagList` | String | List of project tags |
| `userPermissions` | ProjectPermissions! | Permissions for the current user on the resource |
| `visibility` | String | Visibility of the project |
| `webUrl` | String | Web URL of the project |
| `wikiEnabled` | Boolean | (deprecated) Does this project have wiki enabled?. Use `wiki_access_level` instead |

## ProjectPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminOperations` | Boolean! | Indicates the user can perform `admin_operations` on this resource |
| `adminProject` | Boolean! | Indicates the user can perform `admin_project` on this resource |
| `adminRemoteMirror` | Boolean! | Indicates the user can perform `admin_remote_mirror` on this resource |
| `adminWiki` | Boolean! | Indicates the user can perform `admin_wiki` on this resource |
| `archiveProject` | Boolean! | Indicates the user can perform `archive_project` on this resource |
| `changeNamespace` | Boolean! | Indicates the user can perform `change_namespace` on this resource |
| `changeVisibilityLevel` | Boolean! | Indicates the user can perform `change_visibility_level` on this resource |
| `createDeployment` | Boolean! | Indicates the user can perform `create_deployment` on this resource |
| `createDesign` | Boolean! | Indicates the user can perform `create_design` on this resource |
| `createIssue` | Boolean! | Indicates the user can perform `create_issue` on this resource |
| `createLabel` | Boolean! | Indicates the user can perform `create_label` on this resource |
| `createMergeRequestFrom` | Boolean! | Indicates the user can perform `create_merge_request_from` on this resource |
| `createMergeRequestIn` | Boolean! | Indicates the user can perform `create_merge_request_in` on this resource |
| `createPages` | Boolean! | Indicates the user can perform `create_pages` on this resource |
| `createPipeline` | Boolean! | Indicates the user can perform `create_pipeline` on this resource |
| `createPipelineSchedule` | Boolean! | Indicates the user can perform `create_pipeline_schedule` on this resource |
| `createSnippet` | Boolean! | Indicates the user can perform `create_snippet` on this resource |
| `createWiki` | Boolean! | Indicates the user can perform `create_wiki` on this resource |
| `destroyDesign` | Boolean! | Indicates the user can perform `destroy_design` on this resource |
| `destroyPages` | Boolean! | Indicates the user can perform `destroy_pages` on this resource |
| `destroyWiki` | Boolean! | Indicates the user can perform `destroy_wiki` on this resource |
| `downloadCode` | Boolean! | Indicates the user can perform `download_code` on this resource |
| `downloadWikiCode` | Boolean! | Indicates the user can perform `download_wiki_code` on this resource |
| `forkProject` | Boolean! | Indicates the user can perform `fork_project` on this resource |
| `pushCode` | Boolean! | Indicates the user can perform `push_code` on this resource |
| `pushToDeleteProtectedBranch` | Boolean! | Indicates the user can perform `push_to_delete_protected_branch` on this resource |
| `readCommitStatus` | Boolean! | Indicates the user can perform `read_commit_status` on this resource |
| `readCycleAnalytics` | Boolean! | Indicates the user can perform `read_cycle_analytics` on this resource |
| `readDesign` | Boolean! | Indicates the user can perform `read_design` on this resource |
| `readMergeRequest` | Boolean! | Indicates the user can perform `read_merge_request` on this resource |
| `readPagesContent` | Boolean! | Indicates the user can perform `read_pages_content` on this resource |
| `readProject` | Boolean! | Indicates the user can perform `read_project` on this resource |
| `readProjectMember` | Boolean! | Indicates the user can perform `read_project_member` on this resource |
| `readWiki` | Boolean! | Indicates the user can perform `read_wiki` on this resource |
| `removeForkProject` | Boolean! | Indicates the user can perform `remove_fork_project` on this resource |
| `removePages` | Boolean! | Indicates the user can perform `remove_pages` on this resource |
| `removeProject` | Boolean! | Indicates the user can perform `remove_project` on this resource |
| `renameProject` | Boolean! | Indicates the user can perform `rename_project` on this resource |
| `requestAccess` | Boolean! | Indicates the user can perform `request_access` on this resource |
| `updatePages` | Boolean! | Indicates the user can perform `update_pages` on this resource |
| `updateWiki` | Boolean! | Indicates the user can perform `update_wiki` on this resource |
| `uploadFile` | Boolean! | Indicates the user can perform `upload_file` on this resource |

## ProjectStatistics

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `buildArtifactsSize` | Int! | Build artifacts size of the project |
| `commitCount` | Int! | Commit count of the project |
| `lfsObjectsSize` | Int! | Large File Storage (LFS) object size of the project |
| `packagesSize` | Int! | Packages size of the project |
| `repositorySize` | Int! | Repository size of the project |
| `storageSize` | Int! | Storage size of the project |
| `wikiSize` | Int | Wiki size of the project |

## RemoveAwardEmojiPayload

Autogenerated return type of RemoveAwardEmoji

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |

## Repository

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `empty` | Boolean! | Indicates repository has no visible content |
| `exists` | Boolean! | Indicates a corresponding Git repository exists on disk |
| `rootRef` | String | Default branch of the repository |
| `tree` | Tree | Tree of the repository |

## RootStorageStatistics

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `buildArtifactsSize` | Int! | The CI artifacts size in bytes |
| `lfsObjectsSize` | Int! | The LFS objects size in bytes |
| `packagesSize` | Int! | The packages size in bytes |
| `repositorySize` | Int! | The Git repository size in bytes |
| `storageSize` | Int! | The total storage in bytes |
| `wikiSize` | Int! | The wiki size in bytes |

## SentryDetailedError

A Sentry error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int! | Count of occurrences |
| `culprit` | String! | Culprit of the error |
| `externalBaseUrl` | String! | External Base URL of the Sentry Instance |
| `externalUrl` | String! | External URL of the error |
| `firstReleaseLastCommit` | String | Commit the error was first seen |
| `firstReleaseShortVersion` | String | Release version the error was first seen |
| `firstSeen` | Time! | Timestamp when the error was first seen |
| `frequency` | SentryErrorFrequency! => Array | Last 24hr stats of the error |
| `gitlabCommit` | String | GitLab commit SHA attributed to the Error based on the release version |
| `gitlabCommitPath` | String | Path to the GitLab page for the GitLab commit attributed to the error |
| `gitlabIssuePath` | String | URL of GitLab Issue |
| `id` | ID! | ID (global ID) of the error |
| `lastReleaseLastCommit` | String | Commit the error was last seen |
| `lastReleaseShortVersion` | String | Release version the error was last seen |
| `lastSeen` | Time! | Timestamp when the error was last seen |
| `message` | String | Sentry metadata message of the error |
| `sentryId` | String! | ID (Sentry ID) of the error |
| `sentryProjectId` | ID! | ID of the project (Sentry project) |
| `sentryProjectName` | String! | Name of the project affected by the error |
| `sentryProjectSlug` | String! | Slug of the project affected by the error |
| `shortId` | String! | Short ID (Sentry ID) of the error |
| `status` | SentryErrorStatus! | Status of the error |
| `tags` | SentryErrorTags! | Tags associated with the Sentry Error |
| `title` | String! | Title of the error |
| `type` | String! | Type of the error |
| `userCount` | Int! | Count of users affected by the error |

## SentryError

A Sentry error. A simplified version of SentryDetailedError.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int! | Count of occurrences |
| `culprit` | String! | Culprit of the error |
| `externalUrl` | String! | External URL of the error |
| `firstSeen` | Time! | Timestamp when the error was first seen |
| `frequency` | SentryErrorFrequency! => Array | Last 24hr stats of the error |
| `id` | ID! | ID (global ID) of the error |
| `lastSeen` | Time! | Timestamp when the error was last seen |
| `message` | String | Sentry metadata message of the error |
| `sentryId` | String! | ID (Sentry ID) of the error |
| `sentryProjectId` | ID! | ID of the project (Sentry project) |
| `sentryProjectName` | String! | Name of the project affected by the error |
| `sentryProjectSlug` | String! | Slug of the project affected by the error |
| `shortId` | String! | Short ID (Sentry ID) of the error |
| `status` | SentryErrorStatus! | Status of the error |
| `title` | String! | Title of the error |
| `type` | String! | Type of the error |
| `userCount` | Int! | Count of users affected by the error |

## SentryErrorCollection

An object containing a collection of Sentry errors, and a detailed error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `detailedError` | SentryDetailedError | Detailed version of a Sentry error on the project |
| `errorStackTrace` | SentryErrorStackTrace | Stack Trace of Sentry Error |
| `errors` | SentryErrorConnection | Collection of Sentry Errors |
| `externalUrl` | String | External URL for Sentry |

## SentryErrorFrequency

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int! | Count of errors received since the previously recorded time |
| `time` | Time! | Time the error frequency stats were recorded |

## SentryErrorStackTrace

An object containing a stack trace entry for a Sentry error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `dateReceived` | String! | Time the stack trace was received by Sentry |
| `issueId` | String! | ID of the Sentry error |
| `stackTraceEntries` | SentryErrorStackTraceEntry! => Array | Stack trace entries for the Sentry error |

## SentryErrorStackTraceContext

An object context for a Sentry error stack trace

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `code` | String! | Code number of the context |
| `line` | Int! | Line number of the context |

## SentryErrorStackTraceEntry

An object containing a stack trace entry for a Sentry error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `col` | String | Function in which the Sentry error occurred |
| `fileName` | String | File in which the Sentry error occurred |
| `function` | String | Function in which the Sentry error occurred |
| `line` | String | Function in which the Sentry error occurred |
| `traceContext` | SentryErrorStackTraceContext! => Array | Context of the Sentry error |

## SentryErrorTags

State of a Sentry error

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `level` | String | Severity level of the Sentry Error |
| `logger` | String | Logger of the Sentry Error |

## Snippet

Represents a snippet entry

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | The owner of the snippet |
| `blob` | SnippetBlob! | Snippet blob |
| `createdAt` | Time! | Timestamp this snippet was created |
| `description` | String | Description of the snippet |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `fileName` | String | File Name of the snippet |
| `id` | ID! | Id of the snippet |
| `project` | Project | The project the snippet is associated with |
| `rawUrl` | String! | Raw URL of the snippet |
| `title` | String! | Title of the snippet |
| `updatedAt` | Time! | Timestamp this snippet was updated |
| `userPermissions` | SnippetPermissions! | Permissions for the current user on the resource |
| `visibilityLevel` | VisibilityLevelsEnum! | Visibility Level of the snippet |
| `webUrl` | String! | Web URL of the snippet |

## SnippetBlob

Represents the snippet blob

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `binary` | Boolean! | Shows whether the blob is binary |
| `mode` | String | Blob mode |
| `name` | String | Blob name |
| `path` | String | Blob path |
| `plainData` | String | Blob plain highlighted data |
| `rawPath` | String! | Blob raw content endpoint path |
| `richData` | String | Blob highlighted data |
| `richViewer` | SnippetBlobViewer | Blob content rich viewer |
| `simpleViewer` | SnippetBlobViewer! | Blob content simple viewer |
| `size` | Int! | Blob size |

## SnippetBlobViewer

Represents how the blob content should be displayed

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `collapsed` | Boolean! | Shows whether the blob should be displayed collapsed |
| `fileType` | String! | Content file type |
| `loadAsync` | Boolean! | Shows whether the blob content is loaded async |
| `loadingPartialName` | String! | Loading partial name |
| `renderError` | String | Error rendering the blob content |
| `tooLarge` | Boolean! | Shows whether the blob too large to be displayed |
| `type` | BlobViewersType! | Type of blob viewer |

## SnippetPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminSnippet` | Boolean! | Indicates the user can perform `admin_snippet` on this resource |
| `awardEmoji` | Boolean! | Indicates the user can perform `award_emoji` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `readSnippet` | Boolean! | Indicates the user can perform `read_snippet` on this resource |
| `reportSnippet` | Boolean! | Indicates the user can perform `report_snippet` on this resource |
| `updateSnippet` | Boolean! | Indicates the user can perform `update_snippet` on this resource |

## Submodule

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `flatPath` | String! | Flat path of the entry |
| `id` | ID! | ID of the entry |
| `name` | String! | Name of the entry |
| `path` | String! | Path of the entry |
| `sha` | String! | Last commit sha for the entry |
| `treeUrl` | String | Tree URL for the sub-module |
| `type` | EntryType! | Type of tree entry |
| `webUrl` | String | Web URL for the sub-module |

## TaskCompletionStatus

Completion status of tasks

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `completedCount` | Int! | Number of completed tasks |
| `count` | Int! | Number of total tasks |

## Timelog

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `date` | Time! | The date when the time tracked was spent at |
| `issue` | Issue | The issue that logged time was added to |
| `timeSpent` | Int! | The time spent displayed in seconds |
| `user` | User! | The user that logged the time |

## Todo

Representing a todo entry

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `action` | TodoActionEnum! | Action of the todo |
| `author` | User! | The owner of this todo |
| `body` | String! | Body of the todo |
| `createdAt` | Time! | Timestamp this todo was created |
| `group` | Group | Group this todo is associated with |
| `id` | ID! | Id of the todo |
| `project` | Project | The project this todo is associated with |
| `state` | TodoStateEnum! | State of the todo |
| `targetType` | TodoTargetEnum! | Target type of the todo |

## TodoMarkDonePayload

Autogenerated return type of TodoMarkDone

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `todo` | Todo! | The requested todo |

## TodoRestoreManyPayload

Autogenerated return type of TodoRestoreMany

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `updatedIds` | ID! => Array | The ids of the updated todo items |

## TodoRestorePayload

Autogenerated return type of TodoRestore

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `todo` | Todo! | The requested todo |

## TodosMarkAllDonePayload

Autogenerated return type of TodosMarkAllDone

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `updatedIds` | ID! => Array | Ids of the updated todos |

## ToggleAwardEmojiPayload

Autogenerated return type of ToggleAwardEmoji

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `toggledOn` | Boolean! | Indicates the status of the emoji. True if the toggle awarded the emoji, and false if the toggle removed the emoji. |

## Tree

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `lastCommit` | Commit | Last commit for the tree |

## TreeEntry

Represents a directory

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `flatPath` | String! | Flat path of the entry |
| `id` | ID! | ID of the entry |
| `name` | String! | Name of the entry |
| `path` | String! | Path of the entry |
| `sha` | String! | Last commit sha for the entry |
| `type` | EntryType! | Type of tree entry |
| `webUrl` | String | Web URL for the tree entry (directory) |

## UpdateEpicPayload

Autogenerated return type of UpdateEpic

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `epic` | Epic | The epic after mutation |
| `errors` | String! => Array | Reasons why the mutation failed. |

## UpdateImageDiffNotePayload

Autogenerated return type of UpdateImageDiffNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `note` | Note | The note after mutation |

## UpdateIssuePayload

Autogenerated return type of UpdateIssue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `issue` | Issue | The issue after mutation |

## UpdateNotePayload

Autogenerated return type of UpdateNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `note` | Note | The note after mutation |

## UpdateSnippetPayload

Autogenerated return type of UpdateSnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Reasons why the mutation failed. |
| `snippet` | Snippet | The snippet after mutation |

## User

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `avatarUrl` | String | URL of the user's avatar |
| `name` | String! | Human-readable name of the user |
| `userPermissions` | UserPermissions! | Permissions for the current user on the resource |
| `username` | String! | Username of the user. Unique within this instance of GitLab |
| `webUrl` | String! | Web URL of the user |

## UserPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createSnippet` | Boolean! | Indicates the user can perform `create_snippet` on this resource |
